Summary: A runtime binary patcher which modifies code and data in running applications
Name: kaho-cmdtool
Version: 1.0
Release: 5%{?dist}
License: GPL
Group: Applications/System
URL: http://www.miraclelinux.com/ 
Source0: %{name}-%{version}a.tar.gz
BuildRoot: %{_tmppath}/%{name}-root
ExclusiveArch: i386 x86_64

BuildRequires: libstdc++-devel
BuildRequires: kernel-headers
BuildRequires: gcc
BuildRequires: glibc-headers

Patch1: kaho-bp-fix.patch
Patch2: kaho-ss-wait.patch
Patch3: kaho-cmd.patch
Patch4: kaho-patchfile.patch
Patch5: kaho-alloc-load-mem.patch
Patch6: kaho-value-endian.patch
Patch7: kaho-using-mapfile.patch
Patch8: kaho-demangle.patch
Patch9: kaho-target-class-20080528-1.patch
Patch10: kaho-cmdfile-message-20080528-2.patch
Patch11: kaho-value-patch-format-error-20080529-01.patch
Patch12: kaho-shared-library-patch-remaking-20080529-02.patch
Patch13: kaho-cleanup-lockfile.patch
Patch14: kaho-multi-patchfile.patch
Patch15: kaho-static-symbol.patch
Patch16: kaho-resolve-addr.patch

%description
This utility provides a function to modify code and data in the applications without their termination. It is suitable for fixing bugs and security problems of high-availability services that cannot be stopped.

%prep
%setup -q -n %{name}-%{version}
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1
%patch9 -p1
%patch10 -p1
%patch11 -p1
%patch12 -p1
%patch13 -p1
%patch14 -p1
%patch15 -p1
%patch16 -p1

%build
%ifarch x86_64
flg=--enable-x86_64=yes
cflg=-DCONFIG_X86_64
dlib=/usr/lib64
%else
flg=
dlib=/usr/lib
%endif
dbin=/usr/bin

export CFLAGS="$RPM_OPT_FLAGS $cflg "

%configure $flg
make

%install
rm -rf $RPM_BUILD_ROOT
mkdir $RPM_BUILD_ROOT
install -d -m 700  $RPM_BUILD_ROOT%{_includedir}/kaho
install -d -m 700  $RPM_BUILD_ROOT%{_bindir}
install -c -m 0755 kaho  $RPM_BUILD_ROOT%{_bindir}/kaho
install -c -m 0644 kernel/kaho_mod.h $RPM_BUILD_ROOT%{_includedir}/kaho/kaho_mod.h
install -d -m 755  $RPM_BUILD_ROOT%{_var}/lock/kaho


%files
%defattr(-,root,root)
%doc COPYING
%{_bindir}/kaho
%{_includedir}/kaho/kaho_mod.h
%{_var}/lock

%clean
rm -rf $RPM_BUILD_ROOT

%changelog
* Thu Jun 18 2008 Kazuhiro Yamato <kyamato@miraclelinux.com> - 1.0-5%{?dist}
- fix abort when applying data patch [Patch4] (AX#4577)
- fix the infinite memory allocation in pointer patch [Patch5] (AX#4578).
- fix the byte order error when applying data patch [Patch6] (AX#4579).
- fix the termination when the target is stripped [Patch7] (AX#4580).
- fix the wrong demangle on i386 [Patch8] (AX#4581).
- fix the resolution failure in share library patch on i386 [Patch9] (AX#4582).
- fix the wrong line when the error happns [Patch10] (AX#4583).
- fix the problem that does not display error message [Patch11] (AX#4584).
- fix the problem that cuases segmentation fault [Patch12] (AX#4585).
- fix the problem that displays E0005 [Patch13] (AX#4586).
- fix the bug when multiple patch ELFs are specified [Patch14] (AX#4587)
- fix the failure to resolve a static symbol which is in the target function [Patch15] (AX#4589)
- fix the failure to resolve some symbols due to symbol search orgder [Patch16] (AX#4588)
* Thu May 22 2008 Kazuhiro Yamato <kyamato@miraclelinux.com> - 1.0-4%{?dist}
- fix the problem of C++ patch [Patch3] (AX#4592).
- clean up sources (fix typos, fix inappropriate indent, etc)
* Tue May 20 2008 Kazuhiro Yamato <kyamato@miraclelinux.com> - 1.0-3%{?dist}
- fix the SIGSEGV problem [Patch1, Patch2] (AX#4406).
- clean up sources (fix typos, fix inappropriate indent, etc)
* Mon Mar 17 2008 Kazuhiro Yamato <kyamato@miraclelinux.com> - 1.0-2%{?dist}
- fix the spec file for AXS3 SP1 (AX#4020).
* Fri Mar 14 2008 Iwao Shikase <shikase@air.co.jp> - 1.0-1%{?dist}
- Third version.
* Mon Feb 29 2008 Iwao Shikase <shikase@air.co.jp> - 1.0-1%{?dist}
- Second version.
* Mon Feb 18 2008 Iwao Shikase <shikase@air.co.jp> - 1.0-1%{?dist}
- First version.
